
// $Id: converter_core.js,v 1.13 2009/04/11 21:31:02 bogdan Exp $

/*

TO DO:
 - metric weights => imperial weights
 - surfaces
 - volumes
 - update example page with speeds plus everything above
 - example page: adaptive results -- in2m, m2in, kmph2miph, miph2kmph, lb2kg
*/

if (MCE!=undefined && MCE.applicationName=='Converter') {

MCE.core={
	/*
	* This function is the conversion brain -- it takes in a text, checks for
	* values to convert, converts them, executes the adjusters, and if all goes
	* well, returns a converter result object, and false otherwise.
	*/
	doConversion:function(txt,sw)
	{
	  if (sw) {
	    var temp = sw;
	  } else {
	    var temp = this.getSelectedWord(txt);
	    if (!temp) {
	      return false;
	    }
	  }
	  var pos=MCE.util.inArray(temp.unit,MCE.conversions[0]);
	  if (pos==-1) {
	    return false;
	  }
	  if (temp.unit!='internal_time') {
	    temp.value=MCE.util.determine_separators(temp.value);
	  }
	  if (temp.value===false || temp.value===undefined) {
	    return false;
	  }

	  var converter=MCE.conversions[1][pos];
	  // teh problem ist hier ------------------\
	  var cr=eval("MCE.converters."+converter)(temp); // conversion result
	  if (temp.multiplier>1) {
	    cr.inValue*=temp.multiplier;
	    cr.outValue*=temp.multiplier;
	  }
	  // This is rather academic, since we're only using it once below, but hey!
	  // It's a hobby project!
	  if (cr.outUnit=="m") {
	    cr=MCE.adjusters.metricDistance(cr);
	  }
	  if (cr.outUnit=="kg") {
	    cr=MCE.adjusters.metricWeight(cr);
	  }
	  if (cr.outUnit=="in") {
	    cr=MCE.adjusters.imperialDistance(cr);
	  }
	  if ((cr.outUnit=='gal') || (cr.outUnit=='fl oz')) {
	    cr=MCE.adjusters.imperialVolume(cr);
	  }
	  if ((cr.outUnit=='ml') || (cr.outUnit=='L')) {
	    cr=MCE.adjusters.metricVolume(cr);
	  }
	  if (!cr.not_numerical) {
	    cr.inValue=MCE.util.smartRound(cr.inValue);
	    cr.outValue=MCE.util.smartRound(cr.outValue);
	  }
	  if (!cr.outCustom) {
	    cr.outCustom=cr.outValue+" "+cr.outUnit;
	  }
	  return cr;
	},

	/*
	* This function registers the converters defined at the beginning of this
	* file. What it basically does is split that string into items and builds
	* two arrays, one of which contains the units and the other the converters.
	* It then builds an array with two elements which are the arrays previously
	* described, and returns it. It is used by onConverterPopup().
	*/
	registerConverters:function()
	{
	  var conv_symbols=new Array();
	  var conv_functions=new Array();
	  
	  var atoms=MCE.conv_table.split(" ");
	  var conv_symbol=true;
	  var register_extended=true;
	  if (MCE.extended_symbols.length) {
	    register_extended=false;
	  }
	  
	  var i=0;
	  var a_converter_symbol_1=new Array();
	  var a_converter_symbol_2plus=new Array();
	  var dbg_i=0;
	  
	  for(i=0;i<atoms.length;i++) {
	    var atom=atoms[i];
	    if (!atom) {
	      continue;
	    }
	    if (conv_symbol) {
	      if (register_extended && (atom.indexOf('_')>-1)) {
		MCE.extended_symbols_raw[MCE.extended_symbols_raw.length]=atom.replace(/_/g,' ');
		MCE.extended_symbols[MCE.extended_symbols.length]=atom.replace(/_/g,'[\\s]+');
	      }
	      conv_symbols[conv_symbols.length]=atom;
	      if (i<dbg_i) {
		alert('atom: '+atom+' ('+MCE.util.toASCII(atom)+')');
	      }
	      var letter=atom.substring(0,1);
	      if (i<dbg_i) {
		alert("Atom: "+atom+"; letter: "+letter);
	      }
	      if (MCE.util.inArray(letter,a_converter_symbol_1)==-1) {
		a_converter_symbol_1[a_converter_symbol_1.length]=letter;
	//        if (MCE.symbol_1==undefined) {
	//          MCE.symbol_1=letter;
	//        } else {
		  MCE.symbol_1+=letter;
	//        }
	      }
	      var j=0;
	      for(j=1;j<atom.length;j++) {
		letter=atom.substring(j,j+1);
		if (MCE.util.inArray(letter,a_converter_symbol_2plus)==-1) {
		  a_converter_symbol_2plus[a_converter_symbol_2plus.length]=letter;
	//          if (MCE.symbol_2plus==undefined) {
	//            MCE.symbol_2plus=letter;
	//          } else {
		    MCE.symbol_2plus+=letter;
	//          }
		}
	      }
	      if (i<dbg_i) {
		alert(
		  "first: "+a_converter_symbol_1.toString()+"\n"+
		  "2plus: "+a_converter_symbol_2plus.toString()
		);
	      }
	    } else {
	      conv_functions[conv_functions.length]=atom;
	    }
	    conv_symbol=!conv_symbol;
	  }
	  MCE.symbol_1=this.regexpise(MCE.symbol_1);
	  MCE.symbol_2plus=this.regexpise(MCE.symbol_2plus);
	  
	  var result=new Array(conv_symbols,conv_functions);
	  return result;
	},

	/**
	* Transforms a string containing raw, individual characters to be matched
	* by regexp to a form which is actually understood by match()
	*/
	regexpise:function(in_s)
	{
	//  alert('in_s: '+in_s);
	  var i=0;
	  var result=new String;
	  var s=new String(in_s);
	  var re_raw=/[0-9a-zA-Z !"#$%&'*+,.:;<=>?@_`{|}~]/;
	  var re_escape=/[\(\)\-\/\[\\\]\^]/;
	  for(i=0;i<s.length;i++) {
	    var letter=s.substring(i,i+1);
	    var replace=letter;
	    // don't forget about the underscore -- it's never matched here!
	    // standard stuff, goes as is
	    if (!re_raw.exec(letter)) {
	      // stuff that simply needs to be escaped with a backslash
	      if (re_escape.exec(letter)) {
		replace='\\'+replace;
	      } else {
		var hex=replace.charCodeAt(0).toString(16).toUpperCase();
		while(hex.length<4) {
		  hex='0'+hex;
		}
		replace='\\u'+hex;
	      }
	    }
	    result+=replace;
	  }
	//  alert('result: '+result);
	  return result;
	},

	convertPage:function()
	{
	  window.setCursor('wait');
	  if (MCE.util.regressionTest()) {
	    window.setCursor("auto");
	    return true;
	  }
	  var myDocument=content.document;
	  var myBrowser=gBrowser;
	  if (myBrowser.contentWindow.frames.length>0) {
	    for(var i=0;i<gBrowser.contentWindow.frames.length;i++) {
	      var myDocument=gBrowser.contentWindow.frames[i].document;
	      this.convertDoc(myDocument);
	    }
	  }
	  this.convertDoc(gBrowser.contentWindow.document);
	  window.setCursor("auto");
	  return true;
	},

	convertDoc:function(aDoc)
	{
	  MCE.iface.setOldPage(aDoc);
	  if (aDoc.getElementsByTagName('BODY').length) {
	    this.identifyElement(aDoc.getElementsByTagName('BODY')[0]);
	    return true;
	  } else {
	    return false;
	  }
	},

	identifyElement:function(docu)
	{
	  var d=docu;
	  if (d==undefined)
	    return false;
	  do {
	    if (d.nodeType==1) {
	      if (d.nodeName!='SCRIPT')
		this.identifyElement(d.firstChild);
	    } else if (d.nodeType!=8) { // not converting HTML comments
	      var d_content=d.nodeValue;
	      var skip_sibling=false;
	      if (d.nextSibling!=undefined && d.nextSibling.nodeName=='SUP') {
		var sup_index=d_content.length;
		d_content=d_content+'^'+d.nextSibling.firstChild.nodeValue;
		skip_sibling=true;
	      }
	      var re=/[0-9]/;
	      var result=re.exec(d.nodeValue);
	      if (!result) {
		d=d.nextSibling;
		if (skip_sibling) {
		  skip_sibling=false;
		  if (d!=undefined)
		    d=d.nextSibling;
		}
		continue;
	      }
	      //alert('Converting this: '+d.nodeValue);
	      var new_content=this.convertText(d_content);
	      //d.nodeValue=this.convertText(d_content);
	      if (new_content!=d_content) {
		var new_index=sup_index+new_content.length-d_content.length;
		if (new_content.substring(new_index)!=d_content.substring(sup_index)) {
		  d.nodeValue=new_content;
		  if (skip_sibling) {
		    d.parentNode.removeChild(d.nextSibling);
		  }
		} else {
		  d.nodeValue=new_content.substring(0,new_index); // no "+1" because we clear the artificial "^" as well
		}
	      }
	    };
	    d=d.nextSibling;
	    if (skip_sibling) {
	      skip_sibling=false;
	      if (d!=undefined)
		d=d.nextSibling;
	    }
	    // debug: alert('d.nodeType='+d.nodeType+'; d.nodeName='+d.nodeName+'; d.nodeValue='+d.nodeValue);
	  } while (d!=undefined);
	  return true;
	},

	convertText:function(txt)
	{
	  var rawText=new String(txt); // this is the original text which gets chopped
	  //debug: alert('text before: |'+rawText+'|');
	  var re = /\r/g;
	  rawText=rawText.replace(re,' ');
	  re = /\n/g;
	  rawText=rawText.replace(re,' ');
	  //debug: alert('text after: |'+rawText+'|');
	  var convertedText=''; // this is the converted text which grows
	  var wordData=false; // temporary var where we store the result of cGSW()

	  wordData=this.getSelectedWord(rawText)
	  while (wordData) {
	    convertedText=convertedText+rawText.substring(0,wordData.index+wordData.match.length);
	    rawText=rawText.substring(wordData.index+wordData.match.length,rawText.length);
	    var cr=MCE.core.doConversion(wordData.match,wordData);
	    if (cr) {
	      if (!cr.inhibit) {
		if (cr.only_show_converted) {
		  convertedText+=' ('+cr.outCustom+')';
	        } else {
	          convertedText=convertedText+' ('+cr.inValue + " " + cr.inUnit + " = " + cr.outCustom+')';
	        }
	      }
	    }
	    wordData=this.getSelectedWord(rawText)
	  }
	  convertedText=convertedText+rawText;
	  return convertedText;
	},

	getSelectedWord:function(word)
	{
	  var results=[];
	  var tmp;

	  // Let's start by checking for the awkward Imperial notations.
	  
	  // First checking for egineering format (1'2 1/32" or 1'2-1/32").
	  // If found, we convert the whole thing to inches and return as if we
	  // encountered the corresponding string in inches using decimal notation
	  // instead of fractions.
	  var re = /(([0-9]*)\')?([0-9]+)[\s\-]([0-9]+\/[0-9]+)[\s\-]?(\"|inch)/i;
	  var result = re.exec(word);
	  if (result) {
	    if (!result[1])
	      result[1]=0;
	    tmp={};
	    tmp.value=new Number(0);
	    if (result[2]!=undefined) {
	      tmp.value+=new Number(12*result[2]);
	    }
	    tmp.value+=new Number(result[3]);
	    tmp.value+=new Number(eval(result[4]));
	    tmp.unit="in";
	    tmp.match=new String(result[0]);
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }
	  
	  var re = /([0-9]*)\'([0-9]+)[\s\-]([0-9\/]+)/;
	  var result = re.exec(word);
	  if (result) {
	    tmp={};
	    tmp.value=12*result[1]+1*result[2]+eval(result[3]);
	    tmp.unit="in";
	    tmp.match=new String(result[0]);
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }
	  
	  // And finally checking for informal format (5'10)
	  // We first try finding the full format (x'y"), and if that doesn't work,
	  // we look for the simplified format (x'y) -- unfortunately we can't append
	  // ["]? at the end of the first regexp, because it would never match the
	  // final double quote, even if it's there, since it's optional and there's
	  // nothing afterwards to force the regexp algorithm to use it.
	  var re = /([0-9]+)\'[ ]*([0-9]{1,2})\"/;
	  var result = re.exec(word);
	  if (result) {
	    tmp={};
	    tmp.value=12*result[1]+1*result[2];
	    tmp.unit="in";
	    tmp.match=new String(result[0]);
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  } else {
	    var re = /([0-9]+)\'[ ]*([0-9]{1,2})/;
	    var result = re.exec(word);
	    if (result) {
	      tmp={};
	      tmp.value=12*result[1]+1*result[2];
	      tmp.unit="in";
	      tmp.match=new String(result[0]);
	      tmp.index=word.indexOf(result[0]);
	      results.push(tmp);
	    }
	  }

	  // Let's check for extended symbols
	  // Double backslashes below because we need to escape the backslash itself to
	  // get it across the string format. One hour of cursing; idiot, I should have known this.
	  // Changed
	  // ([\\-]?[0-9.][0-9.,\\/]*)[\\s]+
	  // to
	  // ([\\-]?[0-9.][0-9.,\\/]*)[\\s]*
	  // in order to accept "10&deg; F"
	  var re = new RegExp("([\\-]?[0-9.][0-9.,\\/]*)[\\s]*("+MCE.extended_symbols.join('|').replace(/\./g,"\\.")+")","i");
	  var result = re.exec(word);
	  if ((result) && (result[1]) && (result[2])) {
	    var pos=MCE.util.inArray(result[2].toLowerCase().replace(/[\s]+/g,' '),MCE.extended_symbols_raw);
	    if (pos>-1)
	    {
	      //debug: alert('extended match: '+result[1]+'--'+result[2]);
	      tmp={};
	      tmp.value=result[1];
	      tmp.unit=MCE.extended_symbols_raw[pos].replace(/ /g,'_');
	      tmp.match=new String(result[0]);
	      tmp.index=word.indexOf(result[0]);
	      results.push(tmp);
	    }
	  }
	  
	  // 12h/24h
	  //var re = /([0-9]{1,2})(:([0-9]{2}))?(:([0-9]{2}))?[\s]*(am|a\.m\.|pm|p\.m\.)?[\s]*([+\-0-9A-Z]{3,5})?/i;
	  /*
	    This needs to be broken down in two cases ("hh:mm" plus optional stuff, and
	    "hh AM/PM" plus optional stuff); making both ":mm" and "AM/PM" optional
	    results in messy matches which break the processing.
	    ----------
	    Update: the first case above needs to be broken down in two cases as well:
	    "<hh:mm> [am/pm] <TZ>" and "<hh:mm> [am|pm]" in order to properly parse
	    "abc 9:00 AM cba -- abc 9:00 AM cbaza" -- and in the first branch, the <TZ>
	    needs to actually be verified.
	    ----------
	    Update: in the TZ area, the [\s]* is included explicitly because it needs
	    to live in the TZ atom; otherwise "local 9:00 AM in Austria" is improperly
	    spaced.
	    ----------
	    Update: if/else doesn't work well when multiple time formats are shown
	    one after another -- "10 a.m. * 10 p.m. * 10 A.M. * 10 P.M. * 13:33:33 UTC"
	    ----------
	    Update: the military format (0800 GMT) is used more frequently than I
	    had assumed; made the colon optional in all formats in order to support it.
	    ----------
	    Update: the conditions for tmp used to be as follows:
	    if (result && result[1] && (!result[3] || (result[4] && MCE.tzUtil.get_tz_offset(result[4])!=undefined) || (result[5] && MCE.tzUtil.get_tz_offset(result[5])!=undefined))) {

	    I have removed the "!result[3]" condition because it didn't seem to make
	    sense -- result[3] is a blanket generalization and I can't currently
	    understand why it was there in the first place...
	  */
	  var re = /([0-9]{1,2}):?([0-9]{2})(:([0-9]{2}))?[\s]*(am|a\.m\.|pm|p\.m\.)?([\s]*([+\-][0-9]{4})|[\s]*([a-z]{3,4}))?/i;
	  var result = re.exec(word);
	  if (
	    result &&
	    MCE.tzUtil.validate_hour(result[1]) &&
	    MCE.tzUtil.validate_minute(result[2]) &&
	    (
	      (result[5] && !result[6]) ||
	      (
	        result[7] &&
	        MCE.tzUtil.get_tz_offset(result[7])!=undefined
	      ) ||
	      (
	        result[8] &&
	        MCE.tzUtil.get_tz_offset(result[8])!=undefined
	      )
	    )
	  ) {
	    tmp={};
	    tmp.value=result[0];
	    tmp.unit='internal_time'
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // Added version with mandatory colon, because there are some formats
	  // which were "tricking" the optional regexp
	  var re = /([0-9]{1,2}):([0-9]{2})(:([0-9]{2}))?[\s]*(am|a\.m\.|pm|p\.m\.)?([\s]*([+\-][0-9]{4})|[\s]*([a-z]{3,4}))?/i;
	  var result = re.exec(word);
	  if (
	    result &&
	    MCE.tzUtil.validate_hour(result[1]) &&
	    MCE.tzUtil.validate_minute(result[2]) &&
	   (
	     !result[6] ||
	     (
	       result[7] &&
	       MCE.tzUtil.get_tz_offset(result[7])!=undefined) ||
	       (
	         result[8] &&
	         MCE.tzUtil.get_tz_offset(result[8])!=undefined
	       )
	     )
	   ) {
	    tmp={};
	    tmp.value=result[0];
	    tmp.unit='internal_time'
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // There used to be a question mark after the am/pm test, but I removed it
	  // because that was matching (and converting) "2009" and such.
	  var re = /([0-9]{1,2}):?([0-9]{2})(:([0-9]{2}))?[\s]*(am|a\.m\.|pm|p\.m\.)/i;
	  var result = re.exec(word);
	  if (
	    result &&
	    MCE.tzUtil.validate_hour(result[1]) &&
	    MCE.tzUtil.validate_minute(result[2])
	  ) {
	    tmp={};
	    tmp.value=result[0];
	    tmp.unit='internal_time'
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  var re = /([0-9]{1,2})[\s]*(am|a\.m\.|pm|p\.m\.)([\s]*([+\-][0-9]{4})|[\s]*([A-Z]{3,4}))?/i;
	  var result = re.exec(word);
	  if (
	    result &&
	    MCE.tzUtil.validate_hour(result[1]) &&
	    (
	      (
	        !result[4] &&
	        !result[5]
	      ) ||
	      (
	        result[4] &&
	        MCE.tzUtil.get_tz_offset(result[4])!=undefined
	      ) ||
	      (
	        result[5] &&
	        MCE.tzUtil.get_tz_offset(result[5])!=undefined
	      )
	    )
	  ) {
	    if (!result[3]) {
	      result[3]='';
	    } else {
	      result[3]=' '+result[3];
	    }
	    tmp={};
	    tmp.value=result[1]+':00 '+result[2]+result[3];
	    tmp.unit='internal_time'
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // Ok, didn't find any of the wicked ones, let's check for
	  // some reasonable measurements AND fractions.
	  // --- NOTES ---
	  // The last bracket used to include "\-", but I removed it as to allow
	  // converting all of those Imperial idiots' "50-foot monster" and so on.
	  // Hope I didn't mess up, I can't remember whether there was a real reason
	  // for that in here, or whether it was simply a precaution.
	  // -------------
	  // Also, I replaced the second atom,
	  // ([^ .,!?;+\(\)0-9]+)
	  // with
	  // ([^ .,!?;+\(\)0-9][^ .,!?;+\(\)0-9'"]*)
	  // as to allow stuff in quotes -- e.g. "25 kg" -- without messing up the
	  // support for inches (") and feet (').
	  // -------------
	  // Disallowing numbers in the first position for units, because it was
	  // breaking dates
	  // ("Thu, 21 Dec 2000 16:59 -0030" --> it was catching "2000 1")
	  // -------------
	  // Added a "rough" regexp test before the actual test in order to rule out
	  // long strings made of numbers, which made the regexp freeze for way
	  // too long.
	  // -------------
	  // Changed exclusive tests ([^foo]+) with inclusive tests ([bar]+) in order
	  // to avoid various types of mishaps (I had to constantly adjust the
	  // restrictions, and I always failed making it work for all situations).
	  // The CVS version which still contains (imperfect) exclusive tests is 1.42.
	  // -------------
	  // The reason why I allow ([\\d]+[.]?)+ instead of ([\\d])+[.]? is that
	  // I have to account for "6.322.867 feet". Of course, that shouldn't
	  // interfere with 'disabling "Converter 0.6.2" stops FF from freezing',
	  // which used to happen (it used to converte "062 in" instead of "6.2 in").
	  // - END NOTES -

	  // Not using the "proper" stuff here, we just need a rough test (never tested
	  // this version, but it's most probably too strict to be useful, because we
	  // include restrictions based on units, but be DON'T allow stuff
	  // related to other considerations ("thousands", number formatting, etc)
	  //var re = new RegExp("([\\-]?)([\\d,.]+)[\\s]*(["+MCE.symbol_1+"]["+MCE.symbol_2plus+"]+)");
	  // ok, now that we have proper, identical rules for comma- and
	  // period-fractions, we need better safeguards too.
	  // var re = /([\-]?)([\d,.]+)[ ]*([^ .,!?;+\(\)0-9\s]+)/[ignore this bracket]

	  var re = /([\-]?)([\d]+\.|[\d]+|\.|[\d]+,)([\s]*|-)([\d]*)([^ .,!?;+\(\)0-9\s]+)/
	  if (re.exec(word)) {
	    var re = new RegExp("([\\-]?)(((([\\d]+[.]?)+(,[0-9]+)?)|([\\d]*\\.[\\d]+))([/][0-9]+)?)[\\s]*(thousand|million)?[\\s]*(["+MCE.symbol_1+"]["+MCE.symbol_2plus+"]*)","i");
	    var result = re.exec(word);
	    //debug: alert('Matching this: '+word);
	    // Must have the first (result), or the whole thing blows for null results
	    if ((result) && (result[2]) && (result[10])) {
	      //debug: alert('Match -- ['+result[1]+'] -- ['+result[2]+']');
	      var tmpTest=new String(result[2]);
	      var tmp_idx=result[2].indexOf("/");
	      if (tmp_idx!=-1 && tmp_idx!=result[2].length-1) {
		var resultMembers=result[2].split("/");
		for(i=0;i<resultMembers.length;i++) {
		  resultMembers[i]=MCE.util.determine_separators(resultMembers[i]);
		}
		result[2]=eval(resultMembers.join("/"));
	      }
	      var multi=1;
	      if (result[9]) {
		if (result[9]=='million') {
		  multi=1000000;
		} else {
		  multi=1000;
		}
	      }
	      tmp={};
	      tmp.value=result[1]+result[2];
	      tmp.unit=MCE.util.simplify(result[10].toLowerCase());
	      tmp.match=MCE.util.simplify(new String(result[0]));
	      tmp.index=word.indexOf(result[0]);
	      tmp.multiplier=multi;
	      results.push(tmp);
	    }

	    var re = new RegExp("([\\-]?)((([\\d]+[\\,]?)+(\\.[0-9]+)?)([/][0-9]+)?)[\\s]*(thousand|million)?[\\s]*(["+MCE.symbol_1+"]["+MCE.symbol_2plus+"]*)","i");
	    var result = re.exec(word);
	    //debug: alert('Matching this: '+word);
	    // Must have the first (result), or the whole thing blows for null results
	    if ((result) && (result[2]) && (result[8])) {
	      //debug: alert('Match -- ['+result[1]+'] -- ['+result[2]+']');
	      var tmpTest=new String(result[2]);
	      var tmp_idx=result[2].indexOf("/");
	      if (tmp_idx!=-1 && tmp_idx!=result[2].length-1) {
		var resultMembers=result[2].split("/");
		for(i=0;i<resultMembers.length;i++) {
		  resultMembers[i]=MCE.util.determine_separators(resultMembers[i]);
		}
		result[2]=eval(resultMembers.join("/"));
	      }
	      var multi=1;
	      if (result[7]) {
		if (result[7]=='million') {
		  multi=1000000;
		} else {
		  multi=1000;
		}
	      }
	      tmp={};
	      tmp.value=result[1]+result[2];
	      tmp.unit=MCE.util.simplify(result[8].toLowerCase());
	      tmp.match=MCE.util.simplify(new String(result[0]));
	      tmp.index=word.indexOf(result[0]);
	      tmp.multiplier=multi;
	      results.push(tmp);
	    }
	  }

	  // Explicitly looking for 10 foot 5, 10-foot-6, etc
	  // Be advised that this is quite finely tuned, don't mess with it lightly.
	  re = /([0-9]+)[\s\-]*(foot|feet|ft|'|`)[\s\-,]*([0-9]*(\.[0-9]+)?)[\s\-]*?(([0-9]+)\/([0-9]+)[\s\-]*)?([\s]*(inches|inch|in))?/i;
	  result = re.exec(word);
	  if (result) {
	    var fract=0;
	    if (result[5] && (result[7]>0)) {
	      fract=result[6]/result[7];
	    }
	    tmp={};
	    if (result[3] || fract) {
	      tmp.value=12*result[1]+1*result[3]+fract;
	      tmp.unit='in';
	    } else {
	      tmp.value=result[1];
	      tmp.unit='ft';
	    }
	    tmp.match=new String(result[0]);
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // Explicitly looking for 10 foot 1/5, 10-foot-1/6, etc
	  // This is an exact replica of the above, but without the integer part for inches
	  re = /([0-9]+)[\s\-]*(foot|feet|ft|'|`)[\s\-]*(([0-9]+)\/([0-9]+)[\s\-]*)([\s]*(inches|inch|in))?/i;
	  result = re.exec(word);
	  if (result && result[5]>0) {
	    tmp={};
	    tmp.value=12*result[1]+result[4]/result[5];
	    tmp.unit='in';
	    tmp.match=new String(result[0]);
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // Explicitly looking for 11 stone 4
	  re = /([0-9]+)[\s]+stone(s)?[\s]+([0-9]+)/;
	  result = re.exec(word);
	  if (result) {
	    tmp={};
	    tmp.value=Number(result[1])+Number(result[3])/14;
	    tmp.unit='stones';
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    results.push(tmp);
	  }

	  // Currency conversions
	  if (MCE.prefs.getPref('pref_currency_enabled')) {
	    results=results.concat(this.getCurrencyWord(word));
	  }

	  return this.bestAmong(results);
	},

	getCurrencyWord:function(word)
	{
	  var results=[];
	  var tmp;

	  re = /(((([\d]+[.]?)+(,[0-9]+)?)|([\d]*\.[\d]+)))([\-]?)[\s]*([a-z]{3})([a-z]?)/i;
	  result = re.exec(word);
	  if (
	    result &&
	    !result[9] && /* We don't want to convert "3 cops" ("3 COP") */
	    MCE.util.inArray(result[8].toUpperCase(),MCE.currency.currencies)>-1
	  ) {
	    result[8]=result[8].toUpperCase();
	    tmp={};
	    tmp.value=result[1];
	    tmp.unit='internal_currency';
	    tmp.match=result[0];
	    tmp.index=word.indexOf(result[0]);
	    tmp.currency=result[8];
	    results.push(tmp);
	  }

	  return results;
	},

	/*
	* This method compares any number of atoms.
	*/
	bestAmong:function(results)
	{
	  if (!results.length) {
	    return false;
	  }
	  var br=results[0];
	  for(var i=1;i<results.length;i++) {
	    br=this.bestBetween(br,results[i]);
	  }
	  return br;
	},

	/*
	* This method compares two atoms and returns the best fit.
	*
	* By "best fit" I understand applying the following criteria, in this
	* order (i.e. if all things are equal, go on; otherwise, make a decision):
	* 1. The other is no match or it's an all-numeric match (i.e. the matching
	*    string is either empty or only made of digits and spaces);
	* 2. The other shows up later in the original string;
	* 3. The other is shorter;
	* 4. The other's VALUE is smaller -- this is here in order to prevent
	*    Aresult3 (generic) from hijaking Aresult2 (e.g. "3'3"). Given that
	*    this is practically the last meaningful test -- all hh:mm and so on
	*    should have already been sorted out by now, and returing the first one
	*    randomly (as the next decision would) can't be worse than comparing
	*    their magnitudes.
	* 5. Everything's equal so far. But if one of them is currency then we give
	*    that one priority, because we make strict tests for currency validity
	*    on parsing, whereas other units are not so strictly controlled.
	* 6. Return the first one. Well, a decision needs to be made, after all.
	*    Thankfully this happens practically never, and when it does the results are
	*    typically identical anyway (i.e. the same conversion is triggered).
	*    TODO: I could study this in more depth though, maybe by phoning home when
	*    this happens and the units are not the same (with the user's permission,
	*    of course).
	*/
	bestBetween:function(res1,res2)
	{
	  var re=/^[0-9 ]+$/;
	  // (1)
	  if (!res1.match || re.exec(res1.match)) {
	    return res2;
	  }
	  if (!res2.match || re.exec(res2.match)) {
	    return res1;
	  }
	  // (2)
	  if (res1.index<res2.index) {
	    return res1;
	  }
	  if (res1.index>res2.index) {
	    return res2;
	  }
	  // (3)
	  if (res2.match.length>res1.match.length) {
	    return res2;
	  }
	  if (res2.match.length<res1.match.length) {
	    return res1;
	  }
	  // (4)
	  if (res2.value>res1.value) {
	    return res2;
	  }
	  // (5)
	  if (res1.currency!==undefined) {
	    return res1;
	  }
	  if (res2.currency!==undefined) {
	    return res2;
	  }
	  // (6)
	  return res1;
	},

	init:function()
	{
	  MCE.extended_symbols=new Array();
	  MCE.extended_symbols_raw=new Array();
	  MCE.symbol_1=new String();
	  MCE.symbol_2plus=new String();
	  MCE.conversions = MCE.core.registerConverters();
	}
}

MCE.core.init();
}
