
// $Id: converter_util.js,v 1.6 2009/04/08 23:23:18 bogdan Exp $

if (MCE!=undefined && MCE.applicationName=='Converter') {

MCE.util={
	getElementsByTagNTitle:function(tagName,title)
	{
		var elems=content.document.getElementsByTagName("td");
		var results=new Array();
		for(var i=0;i<elems.length;i++) {
			if (elems[i].title==title) {
				results.push(elems[i]);
			}
		}
		return results;
	},

	// Note to self: horrible code duplication in regressionTest()
	regressionTest:function()
	{
	  if (content.document.title!="Converter Regression Test Page {8B72860F-C5F8-4286-865E-D2C2DB98A9E6}") {
	    return false;
	  }

	  // Check version
	  var version_node=content.document.getElementById('intended_version');
	  if (version_node==undefined) {
	    // WTF?
	    return false;
	  }
	  if (version_node.title!=MCE.applicationVersion) {
	    // uh-oh, old one -- show warning
	    version_node.style.display='block';
	    version_node.title='';
	  }

	  var tests=this.getElementsByTagNTitle('td','converter_test');
	  var c_assertions=this.getElementsByTagNTitle('td','contextual_assertion');
	  var c_test=this.getElementsByTagNTitle('td','contextual_test');
	  var p_assertions=this.getElementsByTagNTitle('td','full_page_assertion');
	  var p_test=this.getElementsByTagNTitle('td','full_page_test');
	  var i=0;
	  var color_passed='#AAFFAA';
	  var color_failed='#FFAAAA';
	  var status_text='Some tests have failed:<br><ul>';
	  var status_result=true;
	  for(i=0;i<tests.length;i++) {
	    var test=tests[i].innerHTML;

	    // contextual conversion
	    var cr=MCE.core.doConversion(test,false);
	    c_test[i].style.color='#000000';
	    if (!cr) {
	      if (c_assertions[i].innerHTML=='[no match]') {
		c_test[i].style.backgroundColor=color_passed;
		c_test[i].innerHTML='PASSED';
		c_test[i].style.fontWeight='bold';
		c_test[i].style.textAlign='center';
	      } else {
		c_test[i].style.backgroundColor=color_failed;
		c_test[i].innerHTML='[no match]';
		status_result=false;
		status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    } else if (cr.inhibit) {
	      if (c_assertions[i].innerHTML=='[no conversion]') {
		c_test[i].style.backgroundColor=color_passed;
		c_test[i].innerHTML='PASSED';
		c_test[i].style.fontWeight='bold';
		c_test[i].style.textAlign='center';
	      } else {
		c_test[i].style.backgroundColor=color_failed;
		c_test[i].innerHTML='[no conversion]';
		status_result=false;
		status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    } else {
	      var contextual=cr.inValue + " " + cr.inUnit + " = " + cr.outCustom;
	      if (contextual==c_assertions[i].innerHTML) {
		c_test[i].style.backgroundColor=color_passed;
		c_test[i].innerHTML='PASSED';
		c_test[i].style.fontWeight='bold';
		c_test[i].style.textAlign='center';
	      } else {
		c_test[i].style.backgroundColor=color_failed;
		c_test[i].innerHTML=contextual;
		status_result=false;
		status_text+="<li>Test "+(i+1)+" has failed (contextual).</li>";
	      }
	    }

	    // full page conversion
	    var full_page=MCE.core.convertText(test);
	    p_test[i].style.color='#000000';
	    if (full_page==p_assertions[i].innerHTML) {
	      p_test[i].style.backgroundColor=color_passed;
	      p_test[i].innerHTML='PASSED';
	      p_test[i].style.fontWeight='bold';
	      p_test[i].style.textAlign='center';
	    } else {
	      p_test[i].style.backgroundColor=color_failed;
	      p_test[i].innerHTML=full_page;
	      status_result=false;
	      status_text+="<li>Test "+(i+1)+" has failed (full page).</li>";
	    }
	  }

	  var stat_p=content.document.getElementById('crt_status_p');
	  var stat_span=content.document.getElementById('crt_status_span');
	  if (status_result) {
	    stat_p.style.backgroundColor=color_passed;
	    stat_span.innerHTML='All tests passed successfully.';
	  } else {
	    stat_p.style.backgroundColor=color_failed;
	    stat_span.innerHTML=status_text+"</ul>";
	  }
	  
	  return true;
	},

	/*
	  This function swiped from http://www.mredkj.com/javascript/nfbasic.html
	*/
	addCommas:function(nStr)
	{
	  nStr += '';
	  var x = nStr.split('.');
	  var x1 = x[0];
	  var x2 = x.length > 1 ? '.' + x[1] : '';
	  var rgx = /(\d+)(\d{3})/;
	  while (rgx.test(x1)) {
	    x1 = x1.replace(rgx, '$1' + ',' + '$2');
	  }
	  return x1 + x2;
	},

	smartRound:function(v)
	{
	  var vStr=new String(v);
	  // special case: no decimals--return as such
	  if (vStr.indexOf('.')==-1)
	    return this.addCommas(v);
	  // special case: two decimals at most--return as such
	  /*
	  // Not really useful, I have decided after all.
	  // I might yet revive it though, so I just commented it out for now.
	  if (vStr.indexOf('.')>vStr.length-4)
	    return(this.addCommas(v));
	  */
	  var done=false;
	  var out=new Number(v);
	  var absV=Math.abs(v);
	  for(var val_e=2;!done && val_e>-17;val_e--) {
	    var val=eval('Number(1e'+val_e+')');
	    if (absV>val) {
	      var out=out.toFixed(-val_e+2);
	      done=true;
	    }
	  }
	  out=new String(out);
	  while(out.indexOf('.')>-1 && out.substr(-1,1).match(/[0.]/)) {
	    out=new String(out.substr(0,out.length-1));
	  }
	  if (Number(out)>=1000) {
	    out=this.addCommas(out);
	  }
	  return out;
	},

	/**
	* This function receives a string which presumably contains a number.
	* The number may be formatted with either comma or period as decimal separator,
	* and the other one as thousands separator. This function tries to determine
	* which way it is, defaulting to English format if ambiguous.
	* It returns a proper number.
	*/
	determine_separators:function(s)
	{
	  // We need to get a string, otherwise we don't care at all
	  if (!isNaN(s)) {
	    return s;
	  }
	    
	  try {
	    var tmp=s.indexOf(",");
	  }
	  catch(e) {
	    return s;
	  }
	    
	  /*

	  We used to execute the code below -- which worked well for legitimate
	  numerical situations like "6.382.866 miles", but it was quite lousy
	  at detecting sillier stuff such as <<disable that "version 6.2.2" crap>>,
	  which it ended up converting as "622 inches".

	  So this was replaced with the block of code just below the comment.

	  // Ok, first we'll take the default out of the way
	  if (tmp==-1) {
	    s=s.replace(/\./g,"");
	    return(s);
	  }
	  */

	  // Even here, we need to check whether this makes any sense. Or not.
	  if (tmp==-1) {
	    // check whether we have a properly formatted number
	    var re = /^[\d]{1,3}(\.[\d]{3})*(\.[\d]+)$/
	    if (re.exec(s)) {
	      s=s.replace(/\./g,"");
	      return s;
	    } else {
	      return false;
	    }
	  }

	  // Now we're sure we have a comma in there somewhere. Let's dissect this:
	  if (s.indexOf(".")!=-1) {
	    // Good, we also have a period, this makes it easy to determine which case
	    // it is: the last one is the decimal separator.
	    if (s.lastIndexOf(".")>s.lastIndexOf(",")) {
	      // If it's the period, we just remove the commas and return the string
	      s=s.replace(/,/g,"");
	    } else {
	      // If it's the comma, we remove the periods, change the comma into a
	      // period and return the string.
	      s=s.replace(/\./g,"");
	      s=s.replace(/,/g,".");
	    }
	  } else {
	    // Ewww, this is nasty, we positively have a comma, but we have no
	    // period to serve as a witness. We'll branch in two once again:
	    if (s.indexOf(",")!=s.lastIndexOf(",")) {
	      // Either there's more than one comma, in which case the period would
	      // be the decimal separator...
	      s=s.replace(/,/g,"");
	    } else {
	      // ...or there's a single comma. If there's only one comma, then the
	      // number has only ony chance to be suspected of using comma as a
	      // thousands separator: it MUST be in the proper position for it to be a
	      // thousands separator AND the number must be no larger than 100,000.
	      // In which case we'll ASSUME the default case (period is assumed to be
	      // the decimal separator). This is not perfect, but it's the safest bet.
	      // If either of the conditions above is not met, we'll use the comma
	      // as decimal separator.
	      if ((s.length<=7) && (s.indexOf(",")==s.length-4)) {
		s=s.replace(/,/g,"");
	      } else {
		s=s.replace(/\./g,"");
		s=s.replace(/,/g,".");
	      }
	    }
	  }
	  return s;
	},

	/**
	* A simple function to emulate indexOf() for arrays. Returns the position
	* of the needle in the haystack array, or -1 if not found. Used by
	* onConverterPopup() to determine the units in the selection by matching
	* the 2nd result of MCE.core.getSelectedWord() below against the second array
	* returned by MCE.core.registerConverters() above.
	*/
	inArray:function(needle, haystack)
	{
	  var i=0;
	  for(i=0;i<haystack.length;i++) {
	    var hayAtom=haystack[i];
	    if(needle==hayAtom) {
	      return i;
	    }
	  }
	  return -1;
	},

	/*
	* Just a debug function which is not usually needed
	*/
	toASCII:function(str)
	{
	  var dumpData=new String();
	  for(var i=0;i<str.length;i++) {
	    dumpData=dumpData+str.charCodeAt(i)+', ';
	  }
	  return dumpData;
	},

	simplify:function(word)
	{
	  while(word.substr(word.length-1)=='.') {
	    word=word.substr(0,word.length-1);
	  }
	  return word;
	}
}

}
